#include "stdafx.h"
#include "resource.h"
#include "MainDlg.h"

BOOL IsFile(LPCTSTR szPathName)
{
	DWORD dwRet;
	dwRet = GetFileAttributes(szPathName);
	if(dwRet==0xffffffff) return FALSE;					//  ߻
	if(dwRet & FILE_ATTRIBUTE_DIRECTORY) return FALSE;
	return TRUE;
}

inline BOOL IsFolder(LPCTSTR path) { return PathIsDirectory(path); }

CString	ChangeExt(CString sPathName, CString sNewExt)
{
	int				nPos;
	CString			sResult;
	nPos= sPathName.ReverseFind('.');

	if(sNewExt.Left(1)==_T("."))				// Է ".txt"  "txt"  ٲٱ
		sNewExt = sNewExt.Mid(1);

	if(nPos==-1)								// . ã  ..
		sResult = sPathName +_T(".")+sNewExt;
	else
		sResult = sPathName.Left(nPos)+_T(".")+sNewExt;
	return sResult;
}

CString GetExtFromPath(LPCTSTR szPathName)
{
   TCHAR drive[_MAX_DRIVE];
   TCHAR dir[_MAX_DIR];
   TCHAR fname[_MAX_FNAME];
   TCHAR ext[_MAX_EXT];
//   _tsplitpath( szPathName, drive, dir, fname, ext );
   _tsplitpath_s(szPathName, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, ext, _MAX_EXT );
   return ext;
}
CString GetFileNameFromPath(LPCTSTR szPathName)
{
	LPCTSTR p = szPathName + _tcslen(szPathName)-1;
	while(p>=szPathName)
	{
		if(*p=='\\'||*p=='/'||*p=='|')
			break;
		p--;
	}
	p++;
	return CString(p);
}



CMainDlg::CMainDlg(void)
{
	m_hIcon = ::LoadIcon(_Module.m_hInst, MAKEINTRESOURCE(IDI_MAIN));
	m_bZip2Cbz = TRUE;
}

CMainDlg::~CMainDlg(void)
{
}

LRESULT CMainDlg::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	return 0;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///         ̾˷α ڽ ʱȭ
/// @param  
/// @return 
/// @date   Friday, November 19, 2010  3:43:08 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CMainDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	this->CenterWindow();

	m_scf.Set(GetDlgItem(IDC_STATIC_MESSAGE), FW_BOLD, -7);

	m_hWndMessage = GetDlgItem(IDC_LIST_MESSAGE);

	if(m_bZip2Cbz)
		Button_SetCheck(GetDlgItem(IDC_RADIO_ZIP2CBZ), TRUE);
	else
		Button_SetCheck(GetDlgItem(IDC_RADIO_CBZ2ZIP), TRUE);

	DragAcceptFiles(TRUE);


	return TRUE;
}

LRESULT CMainDlg::OnBnClickedOk(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	//EndDialog(IDOK);
	return 0;
}

LRESULT CMainDlg::OnBnClickedCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(IDCANCEL);
	return 0;
}


LRESULT CMainDlg::OnDropFiles(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	HDROP	hDrop = (HDROP)wParam;
	int		count = DragQueryFile(hDrop, 0xffffffff, NULL, 0);
	TCHAR	filePathName[MAX_PATH];
	int		i;


	while(ListBox_GetCount(m_hWndMessage))
		ListBox_DeleteString(m_hWndMessage, 0);

	for(i=0;i<count;i++)
	{
		DragQueryFile(hDrop, i, filePathName, MAX_PATH);

		if(::IsFile(filePathName))
			ProcessFile(filePathName);
		else if(::IsFolder(filePathName))
			ProcessFolder(filePathName);
	}
	return 0;
}

void CMainDlg::Message(CString msg)
{
	ListBox_AddString(m_hWndMessage, msg);
}

void CMainDlg::ProcessFile(CString pathName)
{
	CString ext;
	CString newExt;

	ext = GetExtFromPath(pathName);
	ext.MakeLower();

	if(m_bZip2Cbz)
	{
		if(ext==L".rar")
			newExt = ".cbr";
		else if(ext==L".zip")
			newExt = ".cbz";
	}
	else
	{
		if(ext==L".cbr")
			newExt = ".rar";
		else if(ext==L".cbz")
			newExt = ".zip";
	}

	if(newExt.IsEmpty()==FALSE)
	{
		CString destPathName = ChangeExt(pathName, newExt);
		CString srcFileName = ::GetFileNameFromPath(pathName);
		CString dstFileName = ::GetFileNameFromPath(destPathName);
		CString msg;

		BOOL success = ::MoveFile(pathName, destPathName);

		msg.Format(L"%s    %s %s", srcFileName, dstFileName, success ? L"" : L" : ");

		Message(msg);
	}

}


#define PATHSEP_CHAR '\\'

void CMainDlg::ProcessFolder(CString folderPathName)
{
	CString	filter = _T("*.*");
	CString	fileName;
	CString	srcPathName;

	WIN32_FIND_DATA findData;
	HANDLE h = FindFirstFile(folderPathName + PATHSEP_CHAR + filter, &findData);

	if(h != INVALID_HANDLE_VALUE)
	{
		do 
		{
			if( wcscmp(findData.cFileName, L".")==0 ||
				wcscmp(findData.cFileName, L"..")==0) continue;

			fileName = findData.cFileName;

			// ̸ Ŀú ȣ
			if(findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				ProcessFolder(folderPathName + PATHSEP_CHAR + fileName);
			else 
				ProcessFile(folderPathName + PATHSEP_CHAR + fileName);

		}
		while(FindNextFile(h, &findData));

		FindClose(h);
	}
}


LRESULT CMainDlg::OnBnClickedRadio(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_bZip2Cbz = Button_GetCheck(GetDlgItem(IDC_RADIO_ZIP2CBZ));
	return 0;
}


