#pragma once

#include "resource.h"
#include "myWindowsx.h"

class CMainDlg : public CDialogImpl <CMainDlg, CWindow>
{
public:
	CMainDlg();
	~CMainDlg();

	enum { IDD = IDD_MAIN};

BEGIN_MSG_MAP(CMainDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnBnClickedOk)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnBnClickedCancel)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_DROPFILES, OnDropFiles)
	COMMAND_HANDLER(IDC_RADIO_ZIP2CBZ, BN_CLICKED, OnBnClickedRadio)
	COMMAND_HANDLER(IDC_RADIO_CBZ2ZIP, BN_CLICKED, OnBnClickedRadio)
END_MSG_MAP()


private :
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnBnClickedOk(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

private :
	void			ProcessFile(CString pathName);
	void			ProcessFolder(CString pathName);
	void			Message(CString msg);

private :
	HICON			m_hIcon;
	CSetControlFont	m_scf;
	BOOL			m_bZip2Cbz;
	HWND			m_hWndMessage;



public:
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDropFiles(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedRadio(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};

