
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////////
//
// PROGRESS BAR

#define Progressbar_SetRange(hWnd, lower, upper) ::SendMessage(hWnd, PBM_SETRANGE, 0, MAKELPARAM(lower, upper));
#define Progressbar_SetPos(hWnd, pos) ::SendMessage(hWnd, PBM_SETPOS, pos, 0);

/*
_AFXCMN_INLINE COLORREF CProgressCtrl::SetBkColor(COLORREF clrNew)
	{ ASSERT(::IsWindow(m_hWnd)); return (COLORREF) ::SendMessage(m_hWnd, PBM_SETBKCOLOR, 0, (LPARAM) clrNew); }
_AFXCMN_INLINE void CProgressCtrl::SetRange(short nLower, short nUpper)
	{ ASSERT(::IsWindow(m_hWnd)); ::SendMessage(m_hWnd, PBM_SETRANGE, 0, MAKELPARAM(nLower, nUpper)); }
_AFXCMN_INLINE void CProgressCtrl::SetRange32(int nLower, int nUpper)
	{ ASSERT(::IsWindow(m_hWnd)); ::SendMessage(m_hWnd, PBM_SETRANGE32, (WPARAM) nLower, (LPARAM) nUpper); }
_AFXCMN_INLINE int CProgressCtrl::GetPos() const
	{ ASSERT(::IsWindow(m_hWnd)); return (int) ::SendMessage(m_hWnd, PBM_GETPOS, 0, 0); }
_AFXCMN_INLINE int CProgressCtrl::OffsetPos(int nPos)
	{ ASSERT(::IsWindow(m_hWnd)); return (int) ::SendMessage(m_hWnd, PBM_DELTAPOS, nPos, 0L); }
_AFXCMN_INLINE int CProgressCtrl::SetStep(int nStep)
	{ ASSERT(::IsWindow(m_hWnd)); return (int) ::SendMessage(m_hWnd, PBM_SETSTEP, nStep, 0L); }
_AFXCMN_INLINE int CProgressCtrl::StepIt()
	{ ASSERT(::IsWindow(m_hWnd)); return (int) ::SendMessage(m_hWnd, PBM_STEPIT, 0, 0L); }
*/



////////////////////////////////////////////////////////////////////////////////////////////////////
//
// LIST CONTROL

inline POSITION ListView_GetFirstSelectedItemPosition(HWND hWnd)
{ 
	return (POSITION)(DWORD_PTR)(1+ListView_GetNextItem(hWnd, -1, LVIS_SELECTED)); 
}

inline int ListView_GetNextSelectedItem(HWND hWnd, POSITION& pos)
{
	DWORD_PTR nOldPos = (DWORD_PTR)pos-1; 
	pos = (POSITION)(DWORD_PTR)(1+ListView_GetNextItem(hWnd, (UINT)nOldPos, LVIS_SELECTED)); 
	return (UINT)nOldPos; 
}

inline void	ListView_SelectItem(HWND hWnd, int pos, BOOL bEnsureVisible=TRUE, BOOL bPartialOK=TRUE)
{
	LVITEM lvi;
	lvi.stateMask = LVIS_SELECTED|LVIS_FOCUSED;
	lvi.state = LVIS_SELECTED|LVIS_FOCUSED;
	::SendMessage(hWnd, LVM_SETITEMSTATE, pos, (LPARAM)&lvi);

	if(bEnsureVisible)
		::SendMessage(hWnd, LVM_ENSUREVISIBLE, (LPARAM)pos,MAKELPARAM(bPartialOK, 0));
}

inline	int	ListView_AddItem(HWND hWnd, LPCTSTR text, LPARAM itemData = 0, int iImage=0)
{
	LVITEM	item;
	item.mask = LVIF_TEXT | LVIF_PARAM | LVIF_IMAGE;
	item.iItem = ListView_GetItemCount(hWnd);
	item.iSubItem = 0;
	item.pszText = (LPTSTR)text;
	item.state = 0;
	item.stateMask = 0;
	item.iImage = iImage;
	item.lParam = itemData;

	return ListView_InsertItem(hWnd, &item);
}

inline void	ListView_AddColumn(HWND hWnd, int column, LPCTSTR text, int width, BOOL bLeftAlign)
{
	LVCOLUMN	lvcolumn;
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcolumn.fmt = bLeftAlign ? LVCFMT_LEFT : LVCFMT_RIGHT;
	lvcolumn.iSubItem = column;
	lvcolumn.pszText = (LPTSTR)text;
	lvcolumn.cx = width;

	ListView_InsertColumn(hWnd, column, &lvcolumn);
}


inline LPARAM ListView_GetItemData(HWND hWnd, int index)
{
	LVITEM	item;
	memset(&item, 0, sizeof(item));
	item.mask = LVIF_PARAM;
	item.iItem = index;
	ListView_GetItem(hWnd, &item);
	return item.lParam;
}


inline	void ListView_SetSelect(HWND hWnd, int itemPos, BOOL bEnsureVisible=TRUE)
{
	LVITEM lvi;
	lvi.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
	lvi.state = LVIS_SELECTED | LVIS_FOCUSED;
	::SendMessage(hWnd, LVM_SETITEMSTATE, itemPos, (LPARAM)&lvi);

	if(bEnsureVisible)
	{
		BOOL bPartialOK = FALSE;
		::SendMessage(hWnd, LVM_ENSUREVISIBLE, (LPARAM)itemPos,MAKELPARAM(bPartialOK, 0));
	}
}


inline	CString ListView_GetItemText2(HWND hWnd, int nItem, int nSubItem)
{
	LVITEM lvi;
	memset(&lvi, 0, sizeof(LVITEM));
	lvi.iSubItem = nSubItem;
	CString str;
	int nLen = 128;
	int nRes;
	do
	{
		nLen *= 2;
		lvi.cchTextMax = nLen;
		lvi.pszText = str.GetBufferSetLength(nLen);
		nRes  = (int)::SendMessage(hWnd, LVM_GETITEMTEXT, (WPARAM)nItem,
			(LPARAM)&lvi);
	} while (nRes >= nLen-1);
	str.ReleaseBuffer();
	return str;
}



////////////////////////////////////////////////////////////////////////////////////////////////////
//
// TREE CONTROL


inline CString TreeView_GetItemText(HWND hWnd, HTREEITEM hItem)
{
	TVITEM item;
	item.hItem = hItem;
	item.mask = TVIF_TEXT;
	CString str;
	int nLen = 128;
	int nRes;
	do
	{
		nLen *= 2;
		item.pszText = str.GetBufferSetLength(nLen);
		item.cchTextMax = nLen;
		::SendMessage(hWnd, TVM_GETITEM, 0, (LPARAM)&item);
		nRes = lstrlen(item.pszText);
	} while (nRes >= nLen-1);
	str.ReleaseBuffer();
	return str;
}

inline HTREEITEM TreeView_GetSelectedItem(HWND hWnd)
{
	return (HTREEITEM)::SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_CARET, 0);
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// button

inline HWND	CreateButton(HWND hWndParent, int id, CRect rBtn, LPCTSTR text)
{
	HWND hWnd = CreateWindowEx(0, WC_BUTTON, text, WS_CHILD | WS_VISIBLE,
			rBtn.left, rBtn.top, rBtn.Width(), rBtn.Height(),
			hWndParent, (HMENU)id, _Module.m_hInst, NULL);
	ASSERT(hWnd);
	return hWnd;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// edit

inline HWND	CreateEdit(HWND hWndParent, int id, CRect rBtn)
{
	HWND hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, NULL, WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL,
			
			rBtn.left, rBtn.top, rBtn.Width(), rBtn.Height(),
			hWndParent, (HMENU)id, _Module.m_hInst, NULL);
	ASSERT(hWnd);
	return hWnd;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// E T C

#define SetRedraw_(hwnd, bRedraw)  ::SendMessage(hwnd, WM_SETREDRAW, (WPARAM)(BOOL)(bRedraw), 0)


inline int Edit_GetCharFromPos(HWND hwnd, CPoint pt)
{
	return (int)::SendMessage(hwnd, EM_CHARFROMPOS, 0, MAKELPARAM(pt.x, pt.y)); 
}

inline CPoint		GetCaretPos()
{
	CPoint point;
	GetCaretPos(&point);
	return point;
}

inline int GetWindowText(HWND hWnd, CString& sText)
{
	int nLen = ::GetWindowTextLength(hWnd);
	::GetWindowText(hWnd, sText.GetBufferSetLength(nLen), nLen+1);
	sText.ReleaseBuffer();
	return nLen;
}

inline BOOL ModifyStyle(HWND m_hWnd, DWORD dwRemove, DWORD dwAdd, UINT nFlags = 0)
{
	DWORD dwStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
	DWORD dwNewStyle = (dwStyle & ~dwRemove) | dwAdd;
	if(dwStyle == dwNewStyle)
		return FALSE;

	::SetWindowLong(m_hWnd, GWL_STYLE, dwNewStyle);
	if(nFlags != 0)
	{
		::SetWindowPos(m_hWnd, NULL, 0, 0, 0, 0,
			SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE | nFlags);
	}

	return TRUE;
}


// Ʈ ۲ ٲٴ Ŭ
class CSetControlFont
{
public :
	CSetControlFont(){}
	~CSetControlFont()
	{
		POSITION p = m_fonts.GetHeadPosition();
		while(p) ::DeleteObject(m_fonts.GetNext(p));
	}
	void Set(HWND hWnd, LONG lfWeight = FW_NORMAL, int heightDelta= 0 )
	{
		HFONT hFontOld = (HFONT)::SendMessage(hWnd, WM_GETFONT, 0,0);
		if(hFontOld==NULL) {ASSERT(0); return;}
		LOGFONT lfont;
		HFONT hFontNew;
		GetObject(hFontOld, sizeof(lfont), &lfont);
		lfont.lfWeight = lfWeight;
		lfont.lfHeight += heightDelta;
		hFontNew = ::CreateFontIndirect(&lfont);
		SendMessage(hWnd, WM_SETFONT, (WPARAM)hFontNew, 0);
		m_fonts.AddTail(hFontNew);
	}
	void Set(HWND hWnd, LPCWSTR fontName)
	{
		HFONT hFontOld = (HFONT)::SendMessage(hWnd, WM_GETFONT, 0,0);
		if(hFontOld==NULL) {ASSERT(0); return;}
		LOGFONT lfont;
		HFONT hFontNew;
		GetObject(hFontOld, sizeof(lfont), &lfont);
		lfont.lfCharSet = SYMBOL_CHARSET;
		lstrcpy(lfont.lfFaceName, fontName);
		hFontNew = ::CreateFontIndirect(&lfont);
		SendMessage(hWnd, WM_SETFONT, (WPARAM)hFontNew, 0);
		m_fonts.AddTail(hFontNew);
	}
	CAtlList<HFONT> m_fonts;
};

